import org.bukkit.Material;
import org.bukkit.plugin.java.JavaPlugin;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.UUID;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.material.MaterialData;
import org.bukkit.material.Sign;
import org.bukkit.World;
import org.bukkit.block.Block;
import org.bukkit.block.BlockFace;
import org.bukkit.block.BlockState;

public class SchilderPlugin extends JavaPlugin {
    private List<Block> schilder;
    private List<UUID> spielerListe;

    public void onEnable(){
        schilder = new ArrayList<Block>();
        spielerListe = new ArrayList<UUID>();
    }

    public void onDisable(){
    }
    
    public boolean onCommand(CommandSender sender, Command befehl, String befehlsname, String[] args){
        if(sender instanceof Player){
            Player spieler = (Player) sender;

            if(args.length < 1){
                spieler.sendMessage("Bitte Schild-Befehl angeben!");
            }
            else if(args[0].equals("bauen")){
                World welt = spieler.getWorld();
                
                //Schild platzieren
                Block finalBlock = welt.getBlockAt(spieler.getLocation());
                List<Block> blockListe = spieler.getLineOfSight((Set<Material>) null, 30);
                
                for(int i = 0; i < blockListe.size(); i++){
                    if(blockListe.get(i).getType() == Material.AIR){
                        finalBlock = blockListe.get(i);
                    }
                    else{
                        break;
                    }
                }
                
                
                Block schildBlock = welt.getBlockAt(finalBlock.getLocation());
                schildBlock.setType(Material.SIGN_POST);
                
                BlockState schildStatus = schildBlock.getState();
                MaterialData schildDaten = schildStatus.getData();
                
                Sign schild = (Sign) schildDaten;
                
                //Rotation
                BlockFace[] rotationen = {BlockFace.SOUTH, BlockFace.SOUTH_SOUTH_WEST, BlockFace.SOUTH_WEST, BlockFace.WEST_SOUTH_WEST, BlockFace.WEST, BlockFace.WEST_NORTH_WEST, BlockFace.NORTH_WEST, BlockFace.NORTH_NORTH_WEST, BlockFace.NORTH, BlockFace.NORTH_NORTH_EAST, BlockFace.NORTH_EAST, BlockFace.EAST_NORTH_EAST, BlockFace.EAST, BlockFace.EAST_SOUTH_EAST, BlockFace.SOUTH_EAST, BlockFace.SOUTH_SOUTH_EAST};

                float rotation = spieler.getLocation().getYaw();
                rotation = (rotation + 180) % 360; //entgegengesetzte Richtung
                rotation = rotation / 22; //umwandeln fuer Schild
                schild.setFacingDirection(rotationen[Math.round(rotation)]);
                
                schildStatus.setData(schild);
                schildStatus.update();
                
                //Schild zur Liste hinzufuegen
                schilder.add(schildBlock);
                spielerListe.add(spieler.getUniqueId());
                spieler.sendMessage("Das neu gebaute Schild hat die ID " + schilder.indexOf(schildBlock));
            }
            else if(args[0].equals("text")){
                if(args.length < 4){
                    spieler.sendMessage("Bitte Schild-ID, Zeile und Text angeben!");
                }
                else{
                    //parameter lesen
                    int schildId = Integer.valueOf(args[1]);
                    int zeile = Integer.valueOf(args[2]);
                    String text = args[3];

                    for(int i = 4; i < args.length; i++){
                        text = text + " " + args[i];
                    }

                    //id pruefen
                    if(schildId < 0 || schildId >= schilder.size()){
                        spieler.sendMessage("Falsche Schild-ID!");
                    }
                    //Spieler pruefen
                    else if(spieler.getUniqueId() != spielerListe.get(schildId)){
                        spieler.sendMessage("Dieses Schild gehoert einem anderen Spieler!");
                    }
                    else{
                        //text zuweisen
                        org.bukkit.block.Sign schildStatus = (org.bukkit.block.Sign) schilder.get(schildId).getState();
                        schildStatus.setLine(zeile, text);
                        schildStatus.update();
                    }
                }
            }
            else{
                spieler.sendMessage("Unbekannter Schild-Befehl!");
            }
        }
        else{
            this.getLogger().info ("Dieser Befehl kann nur von Spielern ausgefuehrt werden.");
        }

        return true;
    }
}