import java.util.HashMap;
import java.util.Random;
import java.util.UUID;

import org.bukkit.Material;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;
import org.bukkit.plugin.PluginManager;
import org.bukkit.plugin.java.JavaPlugin;

public class Sammelspiel extends JavaPlugin {
    public Material gesuchterGegenstand;
    public int anzahl;
    public HashMap<UUID, Integer> gesammelt;
    
    public void onEnable() {
        gesammelt = new HashMap<UUID, Integer>();
        
        PluginManager pluginManager = this.getServer().getPluginManager();
        
        PickupListener listener = new PickupListener(this);
        pluginManager.registerEvents(listener, this);
        
        JoinListener joinListener = new JoinListener(gesammelt, gesuchterGegenstand, anzahl);
        pluginManager.registerEvents(joinListener, this);
        
        neueRundeStarten();
    }
    
    public void neueRundeStarten(){
        Random zufallsgenerator = new Random();
        
        UUID[] spielerListe = gesammelt.keySet().toArray(new UUID[gesammelt.size()]);
        
        for(int i = 0; i < spielerListe.length; i++){
            gesammelt.put(spielerListe[i], 0);
        }

        Material[] gegenstaende = {Material.YELLOW_FLOWER, Material.RED_ROSE, Material.EGG};
        gesuchterGegenstand = gegenstaende[zufallsgenerator.nextInt(gegenstaende.length)];
        anzahl = zufallsgenerator.nextInt(4)+1;
        
        ItemStack g = new ItemStack(gesuchterGegenstand);   
        this.getServer().broadcastMessage("Neue Runde! Sammle " + anzahl + " " + g.getItemMeta().getDisplayName() + "!");
    }
    
    public void onDisable(){
        
    }
    
    public boolean onCommand(CommandSender sender, Command befehl, String befehlsname, String[] args){
        if(sender instanceof Player){
                Player spieler = (Player) sender;
                ItemStack g = new ItemStack(gesuchterGegenstand);
                spieler.sendMessage("Sammle " + anzahl + "x " + g.getItemMeta().getDisplayName() + "!");
        }
        
        return true;
    }
}